package io.renren.modules.admin.service;

import java.util.List;
import java.util.Map;

import com.baomidou.mybatisplus.extension.service.IService;
import io.renren.common.utils.PageUtils;
import io.renren.modules.admin.entity.EmployeeEntity;

/**
 * 
 *
 * @author chenshun
 * @email sunlightcs@gmail.com
 * @date 2020-02-17 13:38:28
 */
public interface EmployeeService extends IService<EmployeeEntity> {

    PageUtils queryPage(Map<String, Object> params);

    PageUtils queryPage(Map<String, Object> params, Long companyId);
    
    PageUtils myQueryPage(Map<String, Object> params);

    List<EmployeeEntity> findAllByisDel(int isDel);

    /**
     * 根据真实姓名模糊查询
     * 
     * @param truename
     * @return
     */
    List<EmployeeEntity> findAllByTrueName(String truename);

    // 多表联查 + 分页
    PageUtils queryList(int page, int limit, String key);

    

    
	void updateEmployee(EmployeeEntity employee);
    
	void saveEmployee(EmployeeEntity employee);
    
    /**
     * 根据真实姓名模糊查询id
     * 
     * @param truename
     * @return
     */
    List<Map<String, Object>> selectNameList(String truename, Long companyId);
    /**
     * 获取工作人员联系方式
     */
    List<Map<String, Object>> getContact(String ids);

    /**
     * 根据单位获取员工列表
     * 
     * @param companyId
     * @return
     */
    Map<Long, String> selectNameListByCompanyId(Long companyId);
}
